/*------------------------------
 *
 * iQ[
 *
 * fight wb_[
 * vC[̊ǗS
 *
------------------------------*/

/*------------------------------
 * DEFINITION(`)
------------------------------*/
#define FIGHT_H									// ܂Ȃ

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// DxLib wb_[

#include "main.h"								// main wb_[
#include "player.h"								// player wb_[

#include "camera.h"								// camera wb_[
#include "fight.h"								// fight wb_[
#include "key.h"								// key wb_[
#include "replay.h"								// replay wb_[

/*------------------------------
 * ֐ FIGHT::init
 * FIGHT̏s
------------------------------*/
void FIGHT::init( int mode )
{
	player1.init(1); player2.init(2);

	state = FIGHT_STARTING;
	time = -1;
	round = 1;
	p1Point = 0; p2Point = 0;
	remain = FIGHTING_TIME;

	position = 0;

	play_mode = mode;

	initCameraPos();
}

/*------------------------------
 * ֐ FIGHT::update
 * FIGHT̃Abvf[gs
------------------------------*/
void FIGHT::update(void)
{

	if( play_mode != FIGHT_PLAYMODE_PLAY ) getReplayNextState(); // vCf[^̎擾
	else recordKeyState();						// vC̕ۑ

	switch( state )
	{
	case FIGHT_STARTING:
		time++;									// Ԍo
		master();								// ̃}X^[

		if( time >= FIGHT_STARTING_TIME - FLAME_SENKOU_NYUURYOKU ) // s͂̎t
		{
			player1.checkPrecede();
			player2.checkPrecede();
		}
		if( time >= FIGHT_STARTING_TIME )
		{
			state = FIGHTING;
			time = 0;

			player1.setCantMove( FALSE );		// 悤ɂ
			player2.setCantMove( FALSE );
			player1.setNoDamage( FALSE );		// _[W炤悤ɂ
			player2.setNoDamage( FALSE );

			player1.actionPrecede();			// s͂̎s
			player2.actionPrecede();
		}
		break;
	case FIGHTING:
		time++;									// Ԍo
		remain--;								// c莞

		master();								// ̃}X^[
		check();								// KO⎞Ԑ؂Ȃǂ̔
		break;
	case FIGHT_KO:
		time++;
		master();

		if( time >= FIGHT_GO_NEXT_ROUND_TIME1 )
			goNextRound();
		break;
	case FIGHT_DOUBLEKO:
		time++;
		master();

		if( time >= FIGHT_GO_NEXT_ROUND_TIME2 )
			goNextRound();
		break;
	case FIGHT_TIMEUP:
		time++;
		master();

		if( time >= FIGHT_GO_NEXT_ROUND_TIME2 )
			goNextRound();
		break;
	case FIGHT_END:
		time++;
		master();

		if( time >= 60 * 4 ) end();
		break;
	}

	if( getKeyState( KEY_INPUT_R ) == 1 || ( play_mode != FIGHT_PLAYMODE_PLAY && ( player1.checkCommand2() || player2.checkCommand2() || getKeyState( KEY_INPUT_RETURN ) == 1 ) ) ) end();
}
/*------------------------------
 * ֐ FIGHT::draw
 * `ʂs
------------------------------*/
void FIGHT::output(void)
{
	/*------------------------------
	 * J̐ݒ
	------------------------------*/
	updateCamera();
	player1.setCameraEff();	player2.setCameraEff();

	/*------------------------------
	 * Xe[W̕\
	------------------------------*/	
	for(int i=-100;i<=100;i+=10)
	{
		DrawLine3D( VGet( -100.0f, 0.0f, i+position ), VGet( 100.0f, 0.0f, i+position ), 0x808080 );
		DrawLine3D( VGet( i, 0.0f, -100.0f ), VGet( i, 0.0f, 100.0f ), 0x808080 );
	}
	/*------------------------------
	 * HP̕\
	------------------------------*/
	DrawBox( 50 - 2, 25 - 2, 340 + 2, 60 + 2, 0x000000, TRUE );
	DrawBox( 340 - (int)( player1.getHPsubf() * 290 ), 25 , 340 , 60 , 0x804040, TRUE );
	DrawBox( 340 - (int)( player1.getHPf() * 290 ), 25 , 340 , 60 , 0xff8080, TRUE );
	DrawBox( 460 - 2 , 25 - 2 , 750 + 2, 60 + 2, 0x000000, TRUE );
	DrawBox( 460 , 25 , 460 + (int)( player2.getHPsubf() * 290 ) , 60 , 0x404080, TRUE );
	DrawBox( 460 , 25 , 460 + (int)( player2.getHPf() * 290 ) , 60 , 0x8080ff, TRUE );

	/*------------------------------
	 * c莞Ԃ̕\
	------------------------------*/
	if( ( remain + 59 ) / 60 <= 5 )
		DrawFormatStringToHandle( 380, 15, 0xff0000, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );
	else if( ( remain + 59 ) / 60 <= 9 )
		DrawFormatStringToHandle( 380, 15, 0xffff00, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );
	else if( ( remain + 59 ) / 60 <= 10 )
		DrawFormatStringToHandle( 357, 15, 0xffff00, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );
	else
		DrawFormatStringToHandle( 357, 15, 0xffffff, FONT_HANDLE3, "%d", ( remain + 59 ) / 60 );

	/*------------------------------
	 * KO̕\
	------------------------------*/
	for(int i=0;i<NANBON;i++)
		DrawFormatStringToHandle( 320 - i * 24, 65, 0x808080, FONT_HANDLE2, "" );
	for(int i=0;i<NANBON;i++)
		DrawFormatStringToHandle( 456 + i * 24, 65, 0x808080, FONT_HANDLE2, "" );
	for(int i=0;i<p1Point;i++)
		DrawFormatStringToHandle( 320 - i * 24, 65, 0xffff00, FONT_HANDLE2, "" );
	for(int i=0;i<p2Point;i++)
		DrawFormatStringToHandle( 456 + i * 24, 65, 0xffff00, FONT_HANDLE2, "" );

	/*------------------------------
	 * {[iX̕\
	------------------------------*/	
	if( player1.getBonus( BONUS_REVERSAL ) ) 
		if( player1.getBonusTime( BONUS_REVERSAL ) < 10 ) DrawFormatStringToHandle(   5-(10-player1.getBonusTime( BONUS_REVERSAL ))*15, 160, 0x80ff80, FONT_HANDLE1, "REVERSAL" );
		else DrawFormatStringToHandle(   5, 160, 0x80ff80, FONT_HANDLE1, "REVERSAL" );
	if( player1.getBonus( BONUS_CRITICAL ) ) 
		if( player1.getBonusTime( BONUS_CRITICAL ) < 10 ) DrawFormatStringToHandle(   5-(10-player1.getBonusTime( BONUS_CRITICAL ))*15, 185, 0xff8080, FONT_HANDLE1, "CRITICAL" );
		else DrawFormatStringToHandle(   5, 185, 0xff8080, FONT_HANDLE1, "CRITICAL" );
	if( player2.getBonus( BONUS_REVERSAL ) ) 
		if( player2.getBonusTime( BONUS_REVERSAL ) < 10 ) DrawFormatStringToHandle( 645+(10-player2.getBonusTime( BONUS_REVERSAL ))*15, 160, 0x80ff80, FONT_HANDLE1, "REVERSAL" );
		else DrawFormatStringToHandle( 645, 160, 0x80ff80, FONT_HANDLE1, "REVERSAL" );
	if( player2.getBonus( BONUS_CRITICAL ) ) 
		if( player2.getBonusTime( BONUS_CRITICAL ) < 10 ) DrawFormatStringToHandle( 645+(10-player2.getBonusTime( BONUS_CRITICAL ))*15, 185, 0xff8080, FONT_HANDLE1, "CRITICAL" );
		else DrawFormatStringToHandle( 645, 185, 0xff8080, FONT_HANDLE1, "CRITICAL" );

	/*------------------------------
	 * vC[̕`
	------------------------------*/
	player1.output();player2.output();
	player1.drawEffect(); player2.drawEffect();

	/*------------------------------
	 * L[fBXvC
	------------------------------*/
	if( play_mode == FIGHT_PLAYMODE_REPLAY ) drawKeyDisplay();

	/*------------------------------
	 * ROUND 1̕\
	------------------------------*/
	if( state == FIGHT_STARTING )
	{
		if(  0 <= time && time < 60  )
		{
			if( p1Point == NANBON - 1 && p2Point == NANBON - 1 )
			{
				DrawStringToHandle( 180, 200, "FINAL", 0x80ff80, FONT_HANDLE4 );
				DrawStringToHandle( 180, 300, "ROUND", 0x80ff80, FONT_HANDLE4 );
			}
			else
				DrawFormatStringToHandle( 120, 250, 0xffffff, FONT_HANDLE4, "ROUND %d", round );
		}
		if( 90 <= time && time < 130 )
			DrawFormatStringToHandle( 185, 250, 0xffffff, FONT_HANDLE4, "READY");
		if(140 <= time && time < 180 )
			DrawFormatStringToHandle( 150, 250, 0xffff00, FONT_HANDLE4, "FIGHT!");

		/*------------------------------
		 * ROUND 1̉
		------------------------------*/
		if( time == 0 )
		{
			if( p1Point == NANBON - 1 && p2Point == NANBON - 1 )
				PlaySoundMem( SE[ SE_FINALROUND ] , DX_PLAYTYPE_BACK );
			else
				PlaySoundMem( SE[ round ] , DX_PLAYTYPE_BACK );
		}
		if( time == 140 )
			PlaySoundMem( SE[ SE_FIGHT ] , DX_PLAYTYPE_BACK );
	}
	else if( state == FIGHT_KO )
	{
		if( player1.getHP() == PLAYER_HP[ 0 ] || player2.getHP() == PLAYER_HP[ 1 ] )
			DrawStringToHandle( 95, 250, "PERFECT", 0xffff00, FONT_HANDLE4 );
		else
			DrawStringToHandle( 270, 250, "K.O.", 0xffffff, FONT_HANDLE4 );

		/*------------------------------
		 * KO, PERFECT, GREAT̉
		------------------------------*/
		if( time == 0 )
		{
			if( player1.getHP() == PLAYER_HP[ 0 ] || player2.getHP() == PLAYER_HP[ 1 ] )
				PlaySoundMem( SE[ SE_PERFECT ] , DX_PLAYTYPE_BACK );
			else
				PlaySoundMem( SE[ SE_KO ] , DX_PLAYTYPE_BACK );
		}
	}
	else if( state == FIGHT_DOUBLEKO )
	{
		DrawStringToHandle( 140, 200, "DOUBLE", 0x80ff80, FONT_HANDLE4 );
		DrawStringToHandle( 270, 300, "K.O.", 0x80ff80, FONT_HANDLE4 );

		/*------------------------------
		 * DOUBLE KỎ
		------------------------------*/
		if( time == 0 )
			PlaySoundMem( SE[ SE_DOUBLEKO ] , DX_PLAYTYPE_BACK );
	}
	else if( state == FIGHT_TIMEUP )
	{
		DrawStringToHandle( 120, 250, "TIME UP", 0x80ffff, FONT_HANDLE4 );

		/*------------------------------
		 * TIME UP̉
		------------------------------*/
		if( time == 0 )
			PlaySoundMem( SE[ SE_TIMEUP ] , DX_PLAYTYPE_BACK );

		/*------------------------------
		 * ^CAbv̗̑͒l̋̓IȐl\
		------------------------------*/
		if( player1.getHPf() >= player2.getHPf() )
			DrawFormatStringToHandle( 240, 175, 0xff0000, FONT_HANDLE2, "%3d %%", (int)( player1.getHPf() * 100 ) );
		else
			DrawFormatStringToHandle( 240, 175, 0xffffff, FONT_HANDLE2, "%3d %%", (int)( player1.getHPf() * 100 ) );
		if( player2.getHPf() >= player1.getHPf() )
			DrawFormatStringToHandle( 460, 175, 0xff0000, FONT_HANDLE2, "%d %%", (int)( player2.getHPf() * 100 ) );
		else
			DrawFormatStringToHandle( 460, 175, 0xffffff, FONT_HANDLE2, "%d %%", (int)( player2.getHPf() * 100 ) );

	}
	else if( state == FIGHT_END )
	{
		if( p1Point >= NANBON && p2Point >= NANBON )
		{
			DrawStringToHandle( 225, 250, "DRAW", 0x80ff80, FONT_HANDLE4 );
		}
		else if( p1Point >= NANBON )
		{
			DrawStringToHandle( 120, 250, "RED WIN", 0xff8080, FONT_HANDLE4 );

			/*------------------------------
			 * REDWIN̉
			------------------------------*/
			if( time == 0 )
				PlaySoundMem( SE[ SE_REDWIN ] , DX_PLAYTYPE_BACK );
		}
		else if( p2Point >= NANBON )
		{
			DrawStringToHandle( 80, 250, "BLUE WIN", 0x8080ff, FONT_HANDLE4 );

			/*------------------------------
			 * BLUEWIN̉
			------------------------------*/
			if( time == 0 )
				PlaySoundMem( SE[ SE_BLUEWIN ] , DX_PLAYTYPE_BACK );
		}
	}

	/*------------------------------
	 * vC[h̕\
	------------------------------*/
	if( play_mode == FIGHT_PLAYMODE_REPLAY && ( COUNT / 15 ) % 4 ) DrawStringToHandle( 270, 500, "REPLAY", 0x808080, FONT_HANDLE3 );
	if( play_mode == FIGHT_PLAYMODE_DEMO && ( COUNT / 15 ) % 4 ) DrawStringToHandle( 215, 500, "DEMO PLAY", 0x808080, FONT_HANDLE3 );
}
/*------------------------------
 * ֐ FIGHT::end
 * I
------------------------------*/
void FIGHT::end(void)
{
	game_state = GAME_TITLE;		// {^^Cg
	stopBGM();						// BGM̒~
	endRecordingReplay();			// vC̒~
}

/*------------------------------
 * ֐ FIGHT::master
 * ̃}X^[s
------------------------------*/
void FIGHT::master(void)
{
	player1.update(); player2.update();			// vC[𓮂

	player1.defenceThis( player2.getWaza() );	// U𓖂Ă
	player2.defenceThis( player1.getWaza() );		

}
/*------------------------------
 * ֐ FIGHT::check
 * ̃}X^[s
------------------------------*/
void FIGHT::check(void)
{
	/*------------------------------
	 * KO
	------------------------------*/
	if( player1.getHP() == 0 && player2.getHP() == 0 )
	{
		state = FIGHT_DOUBLEKO;					// DOUBLE KO
		time = 0;

		p1Point++; p2Point++;
	}
	else if( player1.getHP() == 0 )
	{
		state = FIGHT_KO;						// 1P KO
		time = 0;

		p2Point++;
	}
	else if( player2.getHP() == 0 )
	{
		state = FIGHT_KO;						// 2P KO
		time = 0;

		p1Point++;
	}
	/*------------------------------
	 * ^CAbv
	------------------------------*/
	else if( remain <= 0 )
	{
		if( player1.getHPf() > player2.getHPf() )		// 1p菟
		{
			p1Point++;

			player1.setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2.setNoDamage( TRUE );
		}
		else if( player2.getHPf() > player1.getHPf() ) // 2p菟
		{
			p2Point++;
			player1.setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2.setNoDamage( TRUE );
		}
		else									// 
		{
			p1Point++; p2Point++;
			player1.setNoDamage( TRUE );		// _[WȂ悤ɂ
			player2.setNoDamage( TRUE );
		}

		state = FIGHT_TIMEUP;
		time = 0;
	}
}
/*------------------------------
 * ֐ FIGHT::goNextRound
 * ̃Eh
------------------------------*/
void FIGHT::goNextRound(void)
{
	/*------------------------------
	 * 
	------------------------------*/
	if( p1Point >= NANBON || p2Point >= NANBON )
	{
		state = FIGHT_END;
		time = 0;

		player1.setNoDamage( TRUE );			// _[WȂ悤ɂ
		player2.setNoDamage( TRUE );
		return;
	}	

	/*------------------------------
	 * ̃Eh
	------------------------------*/
	player1.init(1); player2.init(2);
	if( play_mode == FIGHT_PLAYMODE_REPLAY ) resetKeyDisplay();
	initCameraPos();

	state = FIGHT_STARTING;
	time = -1;
	round++;
	remain = FIGHTING_TIME;
}

/*------------------------------
 * ֐ FIGHT::movePosition
 * |WV𓮂
------------------------------*/
void FIGHT::movePosition( double x )
{
	if( player1.getKO() || player2.getKO() ) return;

	position += x;

	if( position < -10.0f ) position += 10.0f;
	else if( position > 10.0f ) position -= 10.0f;
}

/*------------------------------
 * ֐ FIGHT::setReplayMode, getReplayMode
 * vC[h
------------------------------*/
void FIGHT::setReplayMode( int x )
{
	play_mode = x;
}
int FIGHT::getReplayMode(void)
{
	return play_mode;
}