/*------------------------------
 *
 * gamepad R[h
 * Q[pbh̓͏ԂԂ
 *
------------------------------*/

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// DXCuwb_[̃CN[h
#include "gamepad.h"							// gamepad wb_[

/*------------------------------
 * LOCAL PARAMETER([Jϐ)
------------------------------*/
int PAD_NUM;									// pbh̐ڑ
int NOW_PAD1_STATE, NOW_PAD2_STATE;				// ݂̃fW^{^̉
int PRE_PAD1_STATE, PRE_PAD2_STATE;				// 1ÕfW^{^̉
int PAD1_ANALOGX, PAD2_ANALOGX;					// ݂̃o[̏(X)
int PAD1_ANALOGY, PAD2_ANALOGY;					// ݂̃o[̏(Y)

/*------------------------------
 * ֐ initPad
 * Q[pbhg߂̏
------------------------------*/
void initPad(void)
{
	NOW_PAD1_STATE = NOW_PAD2_STATE = PRE_PAD1_STATE = PRE_PAD2_STATE = 0;
	PAD1_ANALOGX = PAD2_ANALOGX = PAD1_ANALOGY = PAD2_ANALOGY = 0;

	PAD_NUM = GetJoypadNum();
}

/*------------------------------
 * ֐ getPadNum
 * Q[pbh̐ڑԂ
------------------------------*/
int getPadNum(void)
{
	return PAD_NUM;
}

/*------------------------------
 * ֐ checkPadState
 * Q[pbh̓͂ǂݍފ֐
------------------------------*/
void checkPadState(void)
{
	PRE_PAD1_STATE = NOW_PAD1_STATE;			// O̓͏Ԃ̋L
	PRE_PAD2_STATE = NOW_PAD2_STATE;

	NOW_PAD1_STATE = GetJoypadInputState( DX_INPUT_PAD1 );
	NOW_PAD2_STATE = GetJoypadInputState( DX_INPUT_PAD2 );
	GetJoypadAnalogInput( &PAD1_ANALOGX, &PAD1_ANALOGY, DX_INPUT_PAD1 );
	GetJoypadAnalogInput( &PAD2_ANALOGX, &PAD2_ANALOGY, DX_INPUT_PAD2 );
												// pbh̓͏Ԃ̎擾
}

/*------------------------------
 * ֐ getPadState
 * Q[pbh̏ԂԂ֐
------------------------------*/
int getPadState( int player, int button )
{
	switch( button )
	{
	case PAD_ANALOGX:
		if( player == 1 )
			return PAD1_ANALOGX;
		else if( player == 2 )
			return PAD2_ANALOGX;
		break;
	case PAD_ANALOGY:
		if( player == 1 )
			return PAD1_ANALOGY;
		else if( player == 2 )
			return PAD2_ANALOGY;
		break;
	case PAD_BUTTON1:
		if( player == 1 )
			return ( ( PRE_PAD1_STATE & PAD_INPUT_1 ) != 0 ) * 2 + ( ( NOW_PAD1_STATE & PAD_INPUT_1 ) != 0 );
		else if( player == 2 )
			return ( ( PRE_PAD2_STATE & PAD_INPUT_1 ) != 0 ) * 2 + ( ( NOW_PAD2_STATE & PAD_INPUT_1 ) != 0 );
		break;
	case PAD_BUTTON2:
		if( player == 1 )
			return ( ( PRE_PAD1_STATE & PAD_INPUT_2 ) != 0 ) * 2 + ( ( NOW_PAD1_STATE & PAD_INPUT_2 ) != 0 );
		else if( player == 2 )
			return ( ( PRE_PAD2_STATE & PAD_INPUT_2 ) != 0 ) * 2 + ( ( NOW_PAD2_STATE & PAD_INPUT_2 ) != 0 );
		break;
	case PAD_BUTTON3:
		if( player == 1 )
			return ( ( PRE_PAD1_STATE & PAD_INPUT_3 ) != 0 ) * 2 + ( ( NOW_PAD1_STATE & PAD_INPUT_3 ) != 0 );
		else if( player == 2 )
			return ( ( PRE_PAD2_STATE & PAD_INPUT_3 ) != 0 ) * 2 + ( ( NOW_PAD2_STATE & PAD_INPUT_3 ) != 0 );
		break;
	case PAD_BUTTON4:
		if( player == 1 )
			return ( ( PRE_PAD1_STATE & PAD_INPUT_4 ) != 0 ) * 2 + ( ( NOW_PAD1_STATE & PAD_INPUT_4 ) != 0 );
		else if( player == 2 )
			return ( ( PRE_PAD2_STATE & PAD_INPUT_4 ) != 0 ) * 2 + ( ( NOW_PAD2_STATE & PAD_INPUT_4 ) != 0 );
		break;
	}

	return 0;
}