/*------------------------------
 *
 * iQ[
 *
 * fight wb_[
 * vC̕ۑĐs
 *
------------------------------*/

#define KEY_DISPLAY_NUM 16						// L[fBXvCŏo͂

/*------------------------------
 * INCLUDION
------------------------------*/
#include "DxLib.h"								// DxLib wb_[

#include "main.h"								// main wb_[
#include "player.h"								// player wb_[
#include "replay.h"								// replay wb_[

#include "stdio.h"								// Wo

/*------------------------------
 * LOCAL PARAMETER
------------------------------*/
const char *name = "replay/replay_data.dat";
FILE *fp = NULL;									// t@C|C^̐錾
unsigned char key;

unsigned char key_dis_p1[KEY_DISPLAY_NUM], key_dis_p2[KEY_DISPLAY_NUM]; 

/*------------------------------
 * vC̕ۑs
------------------------------*/
void startRecordingReplay(void)
{
	if( ( fp = fopen( name, "wb" ) ) == NULL )	// t@C̃I[v
	{
	}											// G[̏ꍇ͉Ȃ
}
void endRecordingReplay(void)
{
	if( fp != NULL ) fclose(fp);				// t@C̃N[Y
	fp = NULL;
}
void recordKeyState(void)
{
	key = 0;

	if( player1.checkCommand1() ) key |= ( 1 << 0 );
	if( player1.checkCommand2() ) key |= ( 1 << 1 );
	if( player1.checkCommand3() ) key |= ( 1 << 2 );
	if( player1.checkCommand4() ) key |= ( 1 << 3 );
	if( player2.checkCommand1() ) key |= ( 1 << 4 );
	if( player2.checkCommand2() ) key |= ( 1 << 5 );
	if( player2.checkCommand3() ) key |= ( 1 << 6 );
	if( player2.checkCommand4() ) key |= ( 1 << 7 );

	fwrite( &key, sizeof( unsigned char ), 1, fp ); // 
}

/*------------------------------
 * vC̍Đs
------------------------------*/
int startPlayingReplay(void)
{
	if( ( fp = fopen( name, "rb" ) ) == NULL )	// t@C̃I[v
	{
		return -1;
	}											// G[̏ꍇ-1

	resetKeyDisplay();

	return 0;
}
void endPlayingReplay(void)
{
	if( fp != NULL ) fclose(fp);				// t@C̃N[Y
	fp = NULL;
}
void getReplayNextState(void)
{
	fread( &key, sizeof( unsigned char ), 1, fp ); // ǂݍ

	updateKeyDisplay( 1, key & 0x0f );
	updateKeyDisplay( 2, key >> 4 );
}
int getReplayKeyState( int p, int k )
{
	if( p == 1 )
	{
		if( k == 1 ) return key & ( 1 << 0 );
		if( k == 2 ) return key & ( 1 << 1 );
		if( k == 3 ) return key & ( 1 << 2 );
		if( k == 4 ) return key & ( 1 << 3 );
	}
	if( p == 2 )
	{
		if( k == 1 ) return key & ( 1 << 4 );
		if( k == 2 ) return key & ( 1 << 5 );
		if( k == 3 ) return key & ( 1 << 6 );
		if( k == 4 ) return key & ( 1 << 7 );	
	}
	
	return -1;
}

void updateKeyDisplay( int p, int k )
{
	if( !k ) return;

	if( p == 1 )
	{
		for(int i=KEY_DISPLAY_NUM-1;i>0;i--)
		{
			key_dis_p1[i] = key_dis_p1[i-1];
		}
		key_dis_p1[0] = k;
	}
	else if( p == 2 )
	{
		for(int i=KEY_DISPLAY_NUM-1;i>0;i--)
		{
			key_dis_p2[i] = key_dis_p2[i-1];
		}
		key_dis_p2[0] = k;
	}
}
void resetKeyDisplay(void)
{
	for(int i=0;i<KEY_DISPLAY_NUM;i++)
	{
		key_dis_p1[i] = 0;
		key_dis_p2[i] = 0;
	}
}
void drawKeyDisplay(void)
{
	int tmp;

	for(int i=0;i<KEY_DISPLAY_NUM;i++)
	{
		if( !key_dis_p1[i] ) break;

		tmp = 0;
		if( key_dis_p1[i] & ( 1 << 1 ) ) { DrawFormatStringToHandle( 15, 100+i*30, 0xff4040, FONT_HANDLE2, "J" ); tmp++; }
		if( key_dis_p1[i] & ( 1 << 2 ) ) { DrawFormatStringToHandle( 15+tmp*30, 100+i*30, 0x4040ff, FONT_HANDLE2, "S" ); tmp++; }
		if( key_dis_p1[i] & ( 1 << 3 ) ) { DrawFormatStringToHandle( 15+tmp*30, 100+i*30, 0xff40ff, FONT_HANDLE2, "H" ); tmp++; }
		if( key_dis_p1[i] & ( 1 << 0 ) ) { DrawFormatStringToHandle( 15+tmp*30, 100+i*30, 0x40ff40, FONT_HANDLE2, "U" ); }
	}
	for(int i=0;i<KEY_DISPLAY_NUM;i++)
	{
		if( !key_dis_p2[i] ) break;

		tmp = 0;
		if( key_dis_p2[i] & ( 1 << 0 ) ) { DrawFormatStringToHandle( 765, 100+i*30, 0x40ff40, FONT_HANDLE2, "U" ); tmp++; }
		if( key_dis_p2[i] & ( 1 << 3 ) ) { DrawFormatStringToHandle( 765-tmp*30, 100+i*30, 0xff40ff, FONT_HANDLE2, "H" ); tmp++; }
		if( key_dis_p2[i] & ( 1 << 2 ) ) { DrawFormatStringToHandle( 765-tmp*30, 100+i*30, 0x4040ff, FONT_HANDLE2, "S" ); tmp++; }
		if( key_dis_p2[i] & ( 1 << 1 ) ) { DrawFormatStringToHandle( 765-tmp*30, 100+i*30, 0xff4040, FONT_HANDLE2, "J" ); }
	}
}